# COYOTE (COmmon Yac Output Toolbox Environment)

## Dependencies
### YAC
- COYOTE depends on [YAC](https://gitlab.dkrz.de/dkrz-sw/yac). To build COYOTE please install YAC first. As coyote is build as a shared library you might want to specify `-fPIC` as a compile flag. The build system of COYOTE detects YAC using `pkgconfig`. Please set `PKG_CONFIG_PATH` accordingly to find YAC.
- COYOTE uses cmakes `FindMPI.cmake` for finding MPI. This **must** be the same MPI version as YAC uses.

## Installation with pip
To use the python interface of COYOTE you can install COYOTE via pip with
```bash
python -m pip install git+https://gitlab.dkrz.de/nils/coyote.git
```

## Installation with ICON on levante
```bash
/sw/spack-levante/python-3.9.9-fwvsvi/bin/python -m venv ./venv --prompt icon
. ./venv/bin/activate
git clone --recursive git@gitlab.dkrz.de:icon/icon.git icon
pushd icon
(cd externals/yac && git checkout release-3.3.0)
mkdir build
cd build
../config/dkrz/levante.gcc --enable-openmp --with-pic --prefix=$(cd ../../venv && pwd -P)
make -j32
(cd externals/yac && make install)
popd
export PKG_CONFIG_PATH=$(pwd -P)/venv/lib/pkgconfig
export MPI_ROOT=/sw/spack-levante/openmpi-4.1.2-mnmady
python -m pip install git+https://gitlab.dkrz.de/nils/coyote.git
```
