#ifndef COYOTE_EVENT_HPP
#define COYOTE_EVENT_HPP

#include <semaphore>

extern "C"{
  #include <yac.h>
}

namespace coyote{

  struct Field{
        Field(const int& target_field_id,
              const std::optional<int>& source_field_id,
              const std::vector<double>& buffer,
              const std::vector<double>& frac_mask,
              const int& collection_size,
              const std::function<void(const Event&)>& eventHandle): 
                yac_target_field_id(target_field_id), 
                yac_source_field_id(source_field_id),
                buffer(buffer),
                frac_mask(frac_mask),
                collection_size(collection_size),
                op(eventHandle){}

    int yac_target_field_id;
    std::optional<int> yac_source_field_id;
    std::vector<double> buffer;
    std::vector<double> frac_mask;
    int collection_size;
    std::function<void(const Event&)> op;
    std::binary_semaphore semaphore = std::binary_semaphore(1);
    int info = YAC_ACTION_NONE;
    bool get_started = false;
  };

  // internally used Event class
  struct FieldBuffer{
    const std::vector<double>& data;
    Field& field;
  };

}

#endif
