#include <yac.h>
#include <stdio.h>

int main(int argc, char** argv){
  yac_cinit();
  yac_cdef_calendar(YAC_PROLEPTIC_GREGORIAN);
  const char* enddate = "2000-01-01T00:10:00.00Z";
  if(argc > 1)
    enddate = argv[1];
  yac_cdef_datetime("2000-01-01T00:00:00.00Z", enddate);
  int comp_id, grid_id, point_id, field_id;
  yac_cdef_comp("simple_source", &comp_id);
  int nbr_points[] = {2, 2};
  int cyclic[] = {0, 0};
  double coords[] = {0., 1.};
  yac_cdef_grid_reg2d ( "simple_grid",
                        nbr_points,
                        cyclic,
                        coords,
                        coords,
                        &grid_id);
  yac_cdef_points_reg2d ( grid_id,
                          nbr_points,
                          YAC_LOCATION_CORNER,
                          coords,
                          coords,
                          &point_id );
  yac_cdef_field("simple_field", comp_id, &point_id, 1,
                 1, "PT1S", YAC_TIME_UNIT_ISO_FORMAT, &field_id);

  yac_cenddef();

  int info = 0, ierror = -1;
  double buffer[] = {0., 1., 2., 3.};
  while(info != YAC_ACTION_PUT_FOR_RESTART){
    printf("putting data %f\n", buffer[0]);
    yac_cput_(field_id,
              1,
              buffer,
              &info,
              &ierror);
    buffer[0] += 1;
  }

  yac_cfinalize();
}
