#!/usr/bin/python3

from coyote import Coyote, run
import numpy as np

coyote = Coyote("test_simple")

coyote.def_grid([4],
                [0., 0., 1., 1.],
                [0., 1., 1., 0.],
                [0, 1, 2, 3],
                [0.5],
                [0.5])


def handler(event):
    data = np.asarray(event.data)
    print(data)
    assert (data.base is not None)  # ensures that this is a view onto the data


coyote.add_field("simple_source",
                 "simple_grid",
                 "simple_field",
                 handler,
                 "PT2S")

run()
