#include <chrono>
#include <cassert>

#include "../src/tsqueue.hpp"

using namespace std::chrono_literals;

int main(){
  TSQueue<int> q;

  std::thread t([&](){
    for(int i = 0; i<10;++i){
      q.enqueue(i*i);
      std::this_thread::sleep_for(5ms);
    }
    q.end();
  });

  for(int i=0; i<10; ++i){
    assert(q.dequeue() == i*i);
  }

  t.join();

  try{
    q.dequeue();
  }catch(QueueTerminated){
    return 0;
  }
  return 1;
}
